const Lang = imports.lang;
const St = imports.gi.St;
const Main = imports.ui.main;
const PanelMenu = imports.ui.panelMenu;
const Util = imports.misc.util;
//gnome 3.0
const Panel = imports.ui.panel;

function ForceQuit() {
    this._init();
}

ForceQuit.prototype = {
    __proto__: PanelMenu.SystemStatusButton.prototype,

    _init: function() {

	PanelMenu.SystemStatusButton.prototype._init.call(this,'force-quit');
        this._button = new St.BoxLayout({ name: 'force-quit'});

        let icon = new St.Icon({ icon_name: 'window-close',
                                 icon_type: St.IconType.FULLCOLOR,
                                 icon_size: 17});

        icon.reactive = true;
        icon.connect('button-press-event', Lang.bind(this, function () {
              Util.spawn(['open','xkill']);
            return true;
        }));

        this._button.add_actor(icon);
        this._button.set_tooltip_text('Click me and select a Window to kill!');

        let _children = Main.panel._leftBox.get_children();
        Main.panel._leftBox.insert_actor(this._button, _children.length - 1);
    },
};

function init(extensionMeta) {
    // do nothing here
}
//gnome3.0
function main() {
    Panel.STANDARD_TRAY_ICON_ORDER.unshift('force-quit');
    Panel.STANDARD_TRAY_ICON_SHELL_IMPLEMENTATION['force-quit'] = ForceQuit;
}

let indicator;

function enable() {
    indicator = new ForceQuit();
    Main.panel.addToStatusArea('force-quit', indicator);
}

function disable() {
    indicator.destroy();
    indicator = null;
}
